]> git.saurik.com Git - bison.git/blame - bootstrap
Add i18n support to the GLR skeleton. Partially fix the C++
[bison.git] / bootstrap
CommitLineData
01c56de4
AD
1#! /bin/sh
2
1f65350a 3# Bootstrap this package from CVS.
01c56de4 4
727e8b0b 5# Copyright (C) 2003, 2004, 2005 Free Software Foundation, Inc.
1f65350a
PE
6
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; either version 2, or (at your option)
10# any later version.
11
12# This program is distributed in the hope that it will be useful,
13# but WITHOUT ANY WARRANTY; without even the implied warranty of
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15# GNU General Public License for more details.
16
17# You should have received a copy of the GNU General Public License
18# along with this program; if not, write to the Free Software
0fb669f9
PE
19# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
20# 02110-1301, USA.
1f65350a
PE
21
22# Written by Paul Eggert.
23
24package=bison
25
a9f027b9
PE
26# Ensure file names are sorted consistently across platforms;
27# e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
28LC_ALL=C
29export LC_ALL
30
1f65350a
PE
31# Parse options.
32
33for option
34do
35 case $option in
36 --help)
37 echo "$0: usage: $0 [--gnulib-srcdir=DIR] [--cvs-user=USERNAME] [--skip-po]"
38 exit;;
39 --gnulib-srcdir=*)
e23d0dd7 40 GNULIB_SRCDIR=`expr "$option" : '--gnulib-srcdir=\(.*\)'`;;
1f65350a 41 --cvs-user=*)
e23d0dd7 42 CVS_USER=`expr "$option" : '--cvs-user=\(.*\)'`;;
1f65350a
PE
43 --skip-po)
44 SKIP_PO=t;;
45 *)
46 echo >&2 "$0: $option: unknown option"
47 exit 1;;
48 esac
49done
50
51echo "$0: Bootstrapping CVS $package..."
52
53build_cvs_prefix() {
54 CVS_PREFIX=:${1}:
55 if [ "${2}" != - ]; then
56 CVS_PREFIX=${CVS_PREFIX}${2}@
57 fi
58}
59
60# Get gnulib files.
61
62case ${GNULIB_SRCDIR--} in
63-)
64 if [ ! -d gnulib ]; then
65 echo "$0: getting gnulib files..."
66
67 trap exit 1 2 13 15
68 trap 'rm -fr gnulib; exit 1' 0
69
70 case ${CVS_AUTH-anoncvs} in
71 anoncvs)
72 CVS_PREFIX='anoncvs@';;
73 ssh)
74 CVS_PREFIX="$CVS_USER${CVS_USER+@}";;
75 *)
76 echo "$0: $CVS_AUTH: Unknown CVS access method" >&2
77 exit 1;;
78 esac
79
80 case $CVS_RSH in
81 '') export CVS_RSH=ssh;;
82 esac
83
84 cvs -z3 -q -d ${CVS_PREFIX}subversions.gnu.org:/cvsroot/gnulib co gnulib || exit
85
727e8b0b 86 trap - 0
1f65350a
PE
87 fi
88 GNULIB_SRCDIR=gnulib
89esac
90
91<$GNULIB_SRCDIR/gnulib-tool || exit
92
93gnulib_modules='
94alloca
95argmatch
96dirname
97error
42e826a4 98extensions
1f65350a 99getopt
c3d5a4a7 100gettext
1f65350a
PE
101hard-locale
102hash
103malloc
104mbswidth
105obstack
106quote
107quotearg
108stdbool
3ea5f0ec 109stdio-safer
1f65350a 110stpcpy
3ea5f0ec 111unistd-safer
1f65350a 112xalloc
a9f027b9 113xalloc-die
1f65350a
PE
114xstrndup
115'
116
117previous_gnulib_modules=
118while [ "$gnulib_modules" != "$previous_gnulib_modules" ]; do
119 previous_gnulib_modules=$gnulib_modules
120 gnulib_modules=`
121 (echo "$gnulib_modules"
122 for gnulib_module in $gnulib_modules; do
123 $GNULIB_SRCDIR/gnulib-tool --extract-dependencies $gnulib_module
124 done) | sort -u
125 `
126done
127
128gnulib_files=`
129 (for gnulib_module in $gnulib_modules; do
130 $GNULIB_SRCDIR/gnulib-tool --extract-filelist $gnulib_module
131 done) | sort -u
132`
133
134gnulib_dirs=`echo "$gnulib_files" | sed 's,/[^/]*$,,' | sort -u`
135mkdir -p $gnulib_dirs || exit
136
137for gnulib_file in $gnulib_files; do
138 dest=$gnulib_file
139
140 case $gnulib_file in
141 m4/onceonly_2_57.m4) dest=m4/onceonly.m4;;
a9f027b9
PE
142 # These will be overwritten by autopoint, which still uses
143 # old jm_.* macro names, so we have to keep both copies.
144 # m4/gettext.m4 isn't mentioned here, since it's patched below.
145 m4/glibc21.m4 | m4/inttypes_h.m4 | m4/lib-ld.m4 | \
146 m4/lib-prefix.m4 | m4/po.m4 | m4/stdint_h.m4 | m4/uintmax_t.m4 | \
147 m4/ulonglong.m4)
148 dest=`expr $gnulib_file : '\(.*\).m4'`_gl.m4;;
1f65350a
PE
149 esac
150
151 rm -f $dest &&
152 echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file" &&
153 cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
154done
155
a9f027b9
PE
156echo "$0: patching m4/gettext.m4 so that AM_INTL_SUBDIR is empty ..."
157sed '
158 /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
159 AC_DEFUN([AM_INTL_SUBDIR], [])
160' m4/gettext.m4 >m4/gettext_gl.m4 || exit
161
1f65350a
PE
162
163# Get translations.
164
165case $SKIP_PO in
166'')
6712933e 167 echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
1f65350a
PE
168 (cd po &&
169 rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'` &&
170 wget -nv -nd -r -l 1 -A .po -C off \
ff498c4a 171 http://www.iro.umontreal.ca/translation/maint/$package/ &&
1f65350a 172 ls *.po | sed 's/\.po$//' >LINGUAS
f7ab6a50
PE
173 ) || exit
174
175 case $package in
176 bison)
177 echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
178 (cd runtime-po &&
179 rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po$/p'` &&
180 wget -nv -nd -r -l 1 -A .po -C off \
181 http://www.iro.umontreal.ca/translation/maint/$package-runtime/ &&
182 ls *.po | sed 's/\.po$//' >LINGUAS
183 ) || exit
184 esac;;
1f65350a
PE
185esac
186
187
188# Generate autoconf and automake snippets.
189
190(echo '# This file is generated automatically by "bootstrap".' &&
191 echo 'AC_DEFUN([GNULIB_AUTOCONF_SNIPPET],[' &&
192 $GNULIB_SRCDIR/gnulib-tool --extract-autoconf-snippet $gnulib_modules &&
193 echo '])'
194) >m4/gnulib.m4 || exit
195
196(echo '# This file is generated automatically by "bootstrap".' &&
197 $GNULIB_SRCDIR/gnulib-tool --extract-automake-snippet $gnulib_modules
198) >lib/gnulib.mk || exit
199
200
201# Reconfigure, getting other files.
202
203echo "$0: autoreconf --verbose --install --force ..."
204autoreconf --verbose --install --force || exit
205
e23d0dd7 206
1f65350a 207# We don't need intl, so remove it.
e23d0dd7
PE
208# Remove aclocal.m4 too, so that it gets rebuilt.
209intl_files_to_remove='
210 aclocal.m4
211 intl
212 m4/codeset.m4
a9f027b9 213 m4/gettext.m4
3ea5f0ec 214 m4/glibc2.m4
e23d0dd7
PE
215 m4/glibc21.m4
216 m4/intdiv0.m4
217 m4/intmax.m4
218 m4/inttypes_h.m4
219 m4/inttypes.m4
220 m4/inttypes-pri.m4
221 m4/isc-posix.m4
222 m4/lcmessage.m4
a9f027b9
PE
223 m4/lib-ld.m4
224 m4/lib-prefix.m4
e23d0dd7
PE
225 m4/longdouble.m4
226 m4/longlong.m4
a9f027b9 227 m4/po.m4
e23d0dd7
PE
228 m4/printf-posix.m4
229 m4/signed.m4
230 m4/size_max.m4
231 m4/stdint_h.m4
232 m4/uintmax_t.m4
233 m4/ulonglong.m4
234 m4/wchar_t.m4
235 m4/wint_t.m4
236 m4/xsize.m4
237'
238echo $0: rm -fr $intl_files_to_remove ...
239rm -fr $intl_files_to_remove || exit
240
1f65350a
PE
241# Put bug-reporting address into po/Makevars.
242echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
243sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars
244
f7ab6a50
PE
245# Likewise for runtime-po/Makevars, except also change a few other parameters.
246sed '
247 s/^\(DOMAIN\) *=.*/\1 = bison-runtime/
248 s/^\(subdir\) *=.*/\1 = runtime-po/
30757c8c 249 s/^\(XGETTEXT_OPTIONS\) *=.*/\1 = --keyword=YY_/
f7ab6a50
PE
250' <po/Makevars >runtime-po/Makevars
251
252# Copy identical files from po to runtime-po.
30757c8c 253(cd po && cp -p Makefile.in.in *-quot *.header *.sed *.sin ../runtime-po)
1f65350a
PE
254
255# if src/parse-gram.[ch] are out of date, rebuild them.
b9c85d5c 256parse_gram_y=`find src/parse-gram.y \
1f65350a 257 '(' -newer src/parse-gram.c -o -newer src/parse-gram.h ')' \
b9c85d5c 258 -print` || exit
1f65350a
PE
259case $parse_gram_y in
260?*)
261 echo "$0: warning: bootstrapping with old src/parse-gram.[ch] files."
262
263 echo "$0: touch -c src/parse-gram.[ch] ... "
264 touch -c src/parse-gram.[ch] || exit
265
266 echo "$0: ./configure --disable-nls ..."
267 ./configure --disable-nls || exit
268
269 echo "$0: (cd lib && make) ..."
270 (cd lib && make) || exit
271
272 echo "$0: (cd src && make) ..."
273 (cd src && make) || exit
274
275 echo "$0: rm -f src/parse-gram.c src/parse-gram.h ..."
276 rm -f src/parse-gram.c src/parse-gram.h || exit
277
278 echo "$0: (cd src && make parse-gram.c parse-gram.h) ..."
279 (cd src && make parse-gram.c parse-gram.h) || exit
280
281 echo "$0: make distclean ..."
282 make distclean || exit;;
283esac
284
285echo "$0: done. Now you can run './configure'."